/**
 * generated by Xtext 2.27.0
 */
package org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.StlTextPackage
 * @generated
 */
public class StlTextSwitch<T> extends Switch<T>
{
  /**
   * The cached model package
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static StlTextPackage modelPackage;

  /**
   * Creates an instance of the switch.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public StlTextSwitch()
  {
    if (modelPackage == null)
    {
      modelPackage = StlTextPackage.eINSTANCE;
    }
  }

  /**
   * Checks whether this is a switch for the given package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param ePackage the package in question.
   * @return whether this is a switch for the given package.
   * @generated
   */
  @Override
  protected boolean isSwitchFor(EPackage ePackage)
  {
    return ePackage == modelPackage;
  }

  /**
   * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the first non-null result returned by a <code>caseXXX</code> call.
   * @generated
   */
  @Override
  protected T doSwitch(int classifierID, EObject theEObject)
  {
    switch (classifierID)
    {
      case StlTextPackage.ASSIGNMENTS:
      {
        assignments assignments = (assignments)theEObject;
        T result = caseassignments(assignments);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.ASSIGNMENT:
      {
        assignment assignment = (assignment)theEObject;
        T result = caseassignment(assignment);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.EXPRESSION:
      {
        expression expression = (expression)theEObject;
        T result = caseexpression(expression);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.EXPRESSION_START:
      {
        expression_start expression_start = (expression_start)theEObject;
        T result = caseexpression_start(expression_start);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.EXPRESSION_CONT:
      {
        expression_cont expression_cont = (expression_cont)theEObject;
        T result = caseexpression_cont(expression_cont);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.REAL_EXPRESSION:
      {
        real_expression real_expression = (real_expression)theEObject;
        T result = casereal_expression(real_expression);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.REAL_EXPRESSION_NL:
      {
        real_expression_nl real_expression_nl = (real_expression_nl)theEObject;
        T result = casereal_expression_nl(real_expression_nl);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.NUM_LITERAL:
      {
        num_literal num_literal = (num_literal)theEObject;
        T result = casenum_literal(num_literal);
        if (result == null) result = caseintervalTime(num_literal);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.INTERVAL:
      {
        interval interval = (interval)theEObject;
        T result = caseinterval(interval);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      case StlTextPackage.INTERVAL_TIME:
      {
        intervalTime intervalTime = (intervalTime)theEObject;
        T result = caseintervalTime(intervalTime);
        if (result == null) result = defaultCase(theEObject);
        return result;
      }
      default: return defaultCase(theEObject);
    }
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>assignments</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>assignments</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseassignments(assignments object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>assignment</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>assignment</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseassignment(assignment object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>expression</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>expression</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseexpression(expression object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>expression start</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>expression start</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseexpression_start(expression_start object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>expression cont</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>expression cont</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseexpression_cont(expression_cont object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>real expression</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>real expression</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T casereal_expression(real_expression object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>real expression nl</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>real expression nl</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T casereal_expression_nl(real_expression_nl object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>num literal</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>num literal</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T casenum_literal(num_literal object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>interval</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>interval</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseinterval(interval object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>interval Time</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>interval Time</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
   * @generated
   */
  public T caseintervalTime(intervalTime object)
  {
    return null;
  }

  /**
   * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
   * <!-- begin-user-doc -->
   * This implementation returns null;
   * returning a non-null result will terminate the switch, but this is the last case anyway.
   * <!-- end-user-doc -->
   * @param object the target of the switch.
   * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
   * @see #doSwitch(org.eclipse.emf.ecore.EObject)
   * @generated
   */
  @Override
  public T defaultCase(EObject object)
  {
    return null;
  }

} //StlTextSwitch
